
#include "opencv2/core.hpp"

#include "opencv2/imgproc.hpp"

using namespace cv;

extern "C" {
Exception * inline_c_OpenCV_ImgProc_GeometricImgTransform_0_c2b99805a51c969cd8f0197f3312633538eae840(Mat * srcPtr_inline_c_0, Mat * dstPtr_inline_c_1, Size2i * dsizePtr_inline_c_2, double fx_inline_c_3, double fy_inline_c_4, int32_t cinterpolation_27_inline_c_5) {

  try
  {   
          cv::resize
          ( *srcPtr_inline_c_0
          , *dstPtr_inline_c_1
          , *dsizePtr_inline_c_2
          , fx_inline_c_3
          , fy_inline_c_4
          , cinterpolation_27_inline_c_5
          );
        
    return NULL;
  }
  catch (const cv::Exception & e)
  {
    return new cv::Exception(e);
  }

}

}

extern "C" {
Exception * inline_c_OpenCV_ImgProc_GeometricImgTransform_1_3de91dcfbe482398170a011285287da39aab63a0(Mat * srcPtr_inline_c_0, Mat * dstPtr_inline_c_1, Mat * transformPtr_inline_c_2, int32_t cinterpolationMethod_27_inline_c_3, int32_t cinverse_27_inline_c_4, int32_t cfillOutliers_27_inline_c_5, int32_t cborderMode_27_inline_c_6, Scalar * borderValuePtr_inline_c_7) {

  try
  {   
            Mat * src = srcPtr_inline_c_0;
            cv::warpAffine
              ( *src
              , *dstPtr_inline_c_1
              , *transformPtr_inline_c_2
              , src->size()
              , cinterpolationMethod_27_inline_c_3 | cinverse_27_inline_c_4 | cfillOutliers_27_inline_c_5
              , cborderMode_27_inline_c_6
              , *borderValuePtr_inline_c_7
              );
          
    return NULL;
  }
  catch (const cv::Exception & e)
  {
    return new cv::Exception(e);
  }

}

}

extern "C" {
Exception * inline_c_OpenCV_ImgProc_GeometricImgTransform_2_4e6ddd0199bf9ac49390a7b6ec8672f793256425(Mat * srcPtr_inline_c_0, Mat * dstPtr_inline_c_1, Mat * transformPtr_inline_c_2, int32_t cinterpolationMethod_27_inline_c_3, int32_t cinverse_27_inline_c_4, int32_t cfillOutliers_27_inline_c_5, int32_t cborderMode_27_inline_c_6, Scalar * borderValuePtr_inline_c_7) {

  try
  {   
            Mat * src = srcPtr_inline_c_0;
            cv::warpPerspective
              ( *src
              , *dstPtr_inline_c_1
              , *transformPtr_inline_c_2
              , src->size()
              , cinterpolationMethod_27_inline_c_3 | cinverse_27_inline_c_4 | cfillOutliers_27_inline_c_5
              , cborderMode_27_inline_c_6
              , *borderValuePtr_inline_c_7
              );
          
    return NULL;
  }
  catch (const cv::Exception & e)
  {
    return new cv::Exception(e);
  }

}

}

extern "C" {
Exception * inline_c_OpenCV_ImgProc_GeometricImgTransform_3_db4c7b21fb82ac16f38778e04e1a21d3c2a15efb(Mat * matInPtr_inline_c_0, Mat * matOutPtr_inline_c_1) {

  try
  {   
           cv::invertAffineTransform(*matInPtr_inline_c_0, *matOutPtr_inline_c_1);
        
    return NULL;
  }
  catch (const cv::Exception & e)
  {
    return new cv::Exception(e);
  }

}

}

extern "C" {
Mat * inline_c_OpenCV_ImgProc_GeometricImgTransform_4_5705994512e2d75b375ec9799d768645b380269b(Point2f * srcPtsPtr_inline_c_0, Point2f * dstPtsPtr_inline_c_1) {

            return new cv::Mat
            ( cv::getPerspectiveTransform(srcPtsPtr_inline_c_0, dstPtsPtr_inline_c_1)
            );
        
}

}

extern "C" {
Mat * inline_c_OpenCV_ImgProc_GeometricImgTransform_5_0ccf603b281c6c9ea50e37bde67fdad2ca9d8fb7(Point2f * centerPtr_inline_c_0, double cangle_27_inline_c_1, double cscale_27_inline_c_2) {

        return new cv::Mat
        ( cv::getRotationMatrix2D
          ( *centerPtr_inline_c_0
          , cangle_27_inline_c_1
          , cscale_27_inline_c_2
          )
        );
      
}

}

extern "C" {
Exception * inline_c_OpenCV_ImgProc_GeometricImgTransform_6_90a3b43830af9c51592b5cfb3eeb2224044835b4(Mat * srcPtr_inline_c_0, Mat * dstPtr_inline_c_1, Mat * mappingPtr_inline_c_2, int32_t cinterpolation_27_inline_c_3, int32_t cborderMode_27_inline_c_4, Scalar * borderValuePtr_inline_c_5) {

  try
  {   
          cv::remap
            ( *srcPtr_inline_c_0
            , *dstPtr_inline_c_1
            , *mappingPtr_inline_c_2
            , {}
            , cinterpolation_27_inline_c_3
            , cborderMode_27_inline_c_4
            , *borderValuePtr_inline_c_5
            );
        
    return NULL;
  }
  catch (const cv::Exception & e)
  {
    return new cv::Exception(e);
  }

}

}

extern "C" {
void inline_c_OpenCV_ImgProc_GeometricImgTransform_7_b911b00f072c7df7d438e470e94acbbfd6dfa9ef(Mat * imgPtr_inline_c_0, Mat * dstPtr_inline_c_1, Mat * cameraPtr_inline_c_2, Mat * distCoeffsPtr_inline_c_3) {

          undistort(*imgPtr_inline_c_0,
                    *dstPtr_inline_c_1,
                    *cameraPtr_inline_c_2,
                    *distCoeffsPtr_inline_c_3);
        
}

}
