
#include "opencv2/core.hpp"

#include "opencv2/video.hpp"

#include "video_motion_analysis.hpp"

using namespace cv;

extern "C" {
Ptr_BackgroundSubtractorKNN * inline_c_OpenCV_Video_MotionAnalysis_0_0a0b275740813683c1bfed73969c25c494b46b98(int32_t chistory_27_inline_c_0, double cdist2Threshold_27_inline_c_1, bool cdetectShadows_27_inline_c_2) {

      cv::Ptr<cv::BackgroundSubtractorKNN> knnPtr =
        cv::createBackgroundSubtractorKNN
        ( chistory_27_inline_c_0
        , cdist2Threshold_27_inline_c_1
        , cdetectShadows_27_inline_c_2
        );
      return new cv::Ptr<cv::BackgroundSubtractorKNN>(knnPtr);
    
}

}

extern "C" {
Ptr_BackgroundSubtractorMOG2 * inline_c_OpenCV_Video_MotionAnalysis_1_6bd1934e204ea96bb8aa587f6a5548311105c7e1(int32_t chistory_27_inline_c_0, double cvarThreshold_27_inline_c_1, bool cdetectShadows_27_inline_c_2) {

      cv::Ptr<cv::BackgroundSubtractorMOG2> mog2Ptr =
        cv::createBackgroundSubtractorMOG2
        ( chistory_27_inline_c_0
        , cvarThreshold_27_inline_c_1
        , cdetectShadows_27_inline_c_2
        );
      return new cv::Ptr<cv::BackgroundSubtractorMOG2>(mog2Ptr);
    
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_2_4a6f75be46ee9ae7f66ce94ff11f820f90a0920e(Ptr_BackgroundSubtractorMOG2 * mog2Ptr_inline_c_0, Mat * imgPtr_inline_c_1, Mat * fgMaskPtr_inline_c_2, double clearningRate_27_inline_c_3) {

              cv::BackgroundSubtractorMOG2 * mog2 = *mog2Ptr_inline_c_0;
              mog2->apply
              ( *imgPtr_inline_c_1
              , *fgMaskPtr_inline_c_2
              , clearningRate_27_inline_c_3
              );
            
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_3_dd637d33bcb924803904d88fe7ac6404770cb2c2(Ptr_BackgroundSubtractorMOG2 * mog2Ptr_inline_c_0, Mat * imgPtr_inline_c_1) {

              cv::BackgroundSubtractorMOG2 * mog2 = *mog2Ptr_inline_c_0;
              mog2->getBackgroundImage(*imgPtr_inline_c_1);
            
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_4_e309b886cafe1283f14b5556398e8236e0b09791(Ptr_BackgroundSubtractorKNN * knnPtr_inline_c_0, Mat * imgPtr_inline_c_1, Mat * fgMaskPtr_inline_c_2, double clearningRate_27_inline_c_3) {

              cv::BackgroundSubtractorKNN * knn = *knnPtr_inline_c_0;
              knn->apply
              ( *imgPtr_inline_c_1
              , *fgMaskPtr_inline_c_2
              , clearningRate_27_inline_c_3
              );
            
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_5_acc3fe34d3592ae448faa1c398acf9aefbe9cdbf(Ptr_BackgroundSubtractorKNN * knnPtr_inline_c_0, Mat * imgPtr_inline_c_1) {

              cv::BackgroundSubtractorKNN * knn = *knnPtr_inline_c_0;
              knn->getBackgroundImage(*imgPtr_inline_c_1);
            
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_6_31db6e29933a955292a26fc8a2f21656f0264fc0(Ptr_BackgroundSubtractorMOG2 * mog2Ptr_inline_c_0) {

              cv::BackgroundSubtractorMOG2 * mog2 = *mog2Ptr_inline_c_0;
              mog2->clear();
          
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_7_778ae04bc23f9731f5715891f6c00c2e233cfae3(Ptr_BackgroundSubtractorMOG2 * mog2Ptr_inline_c_0, bool * emptyPtr_inline_c_1) {

              cv::BackgroundSubtractorMOG2 * mog2 = *mog2Ptr_inline_c_0;
              *emptyPtr_inline_c_1 = mog2->empty();
          
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_8_6d32d18fa950d5c3ad83fd26ae6d6fb09e7a8372(Ptr_BackgroundSubtractorKNN * knnPtr_inline_c_0) {

              cv::BackgroundSubtractorKNN * knn = *knnPtr_inline_c_0;
              knn->clear();
          
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_9_7be48f700e60c4da4e297a30717dc1fb9252896c(Ptr_BackgroundSubtractorKNN * knnPtr_inline_c_0, bool * emptyPtr_inline_c_1) {

              cv::BackgroundSubtractorKNN * knn = *knnPtr_inline_c_0;
              *emptyPtr_inline_c_1 = knn->empty();
          
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_10_c5f690e42d74da8f96ffec2e1798eec5b52382be(Ptr_BackgroundSubtractorMOG2 * ptr_inline_c_0) {

                  cv::Ptr<cv::BackgroundSubtractorMOG2> * mog2_ptr_ptr =
                    ptr_inline_c_0;
                  mog2_ptr_ptr->release();
                  delete mog2_ptr_ptr;
                
}

}

extern "C" {
void inline_c_OpenCV_Video_MotionAnalysis_11_27d85d129e9b7f1552b33141a9a7575fe19563bc(Ptr_BackgroundSubtractorKNN * ptr_inline_c_0) {

                  cv::Ptr<cv::BackgroundSubtractorKNN> * knn_ptr_ptr =
                    ptr_inline_c_0;
                  knn_ptr_ptr->release();
                  delete knn_ptr_ptr;
                
}

}
